window.Gleam.initSearch([{"doc":"migrant","title":"migrant","content":"# Migrant\n\nDatabase migrations for SQLite in Gleam\n\n## Usage\n\n```gleam\nimport gleam/erlang\nimport app/database\nimport migrant\n\npub fn main() {\n  let db = database.connect()\n\n  let assert Ok(priv_directory) = erlang.priv_directory(&quot;app&quot;)\n  let assert Ok(_) = migrant.migrate(db, priv_directory &lt;&gt; &quot;/migrations&quot;)\n\n  Nil\n}\n```\n\n## Installation\n\nThis library is currently being developed as it is used in projects &amp; as needed, there are no stable (or really any) releases yet and there won&#39;t be for a while.\nIf you want to use it regardless, you can install it as a local dependency by cloning this repo and adding this to your `gleam.toml` file\n\n&gt; UPDATE: there is an alpha release now (for convenience), use at your own risk\n\n```toml\n[dependencies]\nmigrant = { path = &quot;path/to/migrant&quot; }\n```\n\n### Installing Alpha from Hex\n\nAgain, this has not been thoroughly tested, it has been built to suit what I need at the moment, use at your own risk.\n\n```sh\ngleam add migrant\n```\n\n## Targets\n\nIn theory, this should work in both Javascript and Erlang targets since all the dependencies have support for both targets, but it is only currently being developed and tested against the Erlang/BEAM runtime.\n","url":"index.html"},{"doc":"migrant/types","title":"Error","content":"pub type Error {\n  ExpectedFolderError\n  FileError(simplifile.FileError)\n  FilenameError(message: String)\n  ExtractionError(message: String)\n  DatabaseError(sqlight.Error)\n  MigrationError(message: String, err: Error)\n  RollbackError\n}\n\nExpectedFolderError\n\n\nFileError(simplifile.FileError)\n\n\nFilenameError(message: String)\n\n\nExtractionError(message: String)\n\n\nDatabaseError(sqlight.Error)\n\n\nMigrationError(message: String, err: Error)\n\n\nRollbackError\n\n\nSynonyms:\nmigrant/types.Error\nmigrant/types Error","url":"migrant/types.html#Error"},{"doc":"migrant/types","title":"Migration","content":"pub type Migration {\n  Migration(up: Option(String), down: Option(String))\n}\n\nMigration(up: Option(String), down: Option(String))\n\n\nSynonyms:\nmigrant/types.Migration\nmigrant/types Migration","url":"migrant/types.html#Migration"},{"doc":"migrant/types","title":"Migrations","content":"pub type Migrations =\n  Dict(String, Migration)\n\n\nSynonyms:\nmigrant/types.Migrations\nmigrant/types Migrations","url":"migrant/types.html#Migrations"},{"doc":"migrant/types","title":"migrant/types","content":"","url":"migrant/types.html"},{"doc":"migrant/database","title":"QueryResult","content":"pub type QueryResult(a) =\n  Result(List(a), Error)\n\n\nSynonyms:\nmigrant/database.QueryResult\nmigrant/database QueryResult","url":"migrant/database.html#QueryResult"},{"doc":"migrant/database","title":"apply_migrations","content":"pub fn apply_migrations(\n  db: Connection,\n  migrations: Dict(String, Migration),\n) -&gt; Result(Nil, Error)\n\nSynonyms:\nmigrant/database.apply_migrations\nmigrant/database apply_migrations","url":"migrant/database.html#apply_migrations"},{"doc":"migrant/database","title":"create_migrations_table","content":"pub fn create_migrations_table(\n  db: Connection,\n  next: fn() -&gt; Result(Nil, Error),\n) -&gt; Result(Nil, Error)\n\nSynonyms:\nmigrant/database.create_migrations_table\nmigrant/database create_migrations_table","url":"migrant/database.html#create_migrations_table"},{"doc":"migrant/database","title":"exec","content":"pub fn exec(db: Connection, sql: String) -&gt; Result(Nil, Error)\n\nSynonyms:\nmigrant/database.exec\nmigrant/database exec","url":"migrant/database.html#exec"},{"doc":"migrant/database","title":"filter_applied_migrations","content":"pub fn filter_applied_migrations(\n  db: Connection,\n  migrations: Dict(String, Migration),\n  next: fn(Dict(String, Migration)) -&gt; Result(Nil, Error),\n) -&gt; Result(Nil, Error)\n\nSynonyms:\nmigrant/database.filter_applied_migrations\nmigrant/database filter_applied_migrations","url":"migrant/database.html#filter_applied_migrations"},{"doc":"migrant/database","title":"query","content":"pub fn query(\n  db: Connection,\n  query sql: String,\n  args args: List(Value),\n  decoder decoder: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n) -&gt; Result(List(a), Error)\n\nSynonyms:\nmigrant/database.query\nmigrant/database query","url":"migrant/database.html#query"},{"doc":"migrant/database","title":"migrant/database","content":"","url":"migrant/database.html"},{"doc":"migrant/lib","title":"get_or_make_migration","content":"pub fn get_or_make_migration(\n  name: String,\n  migrations: Dict(String, Migration),\n  next: fn(Migration) -&gt; Result(#(String, Migration), Error),\n) -&gt; Result(#(String, Migration), Error)\n\nSynonyms:\nmigrant/lib.get_or_make_migration\nmigrant/lib get_or_make_migration","url":"migrant/lib.html#get_or_make_migration"},{"doc":"migrant/lib","title":"validate_direction","content":"pub fn validate_direction(\n  direction: String,\n  next: fn(String) -&gt; Result(#(String, Migration), Error),\n) -&gt; Result(#(String, Migration), Error)\n\nSynonyms:\nmigrant/lib.validate_direction\nmigrant/lib validate_direction","url":"migrant/lib.html#validate_direction"},{"doc":"migrant/lib","title":"migrant/lib","content":"","url":"migrant/lib.html"},{"doc":"migrant/filesystem","title":"load_migration_files","content":"pub fn load_migration_files(\n  migrations_dir: String,\n  next: fn(Dict(String, Migration)) -&gt; Result(Nil, Error),\n) -&gt; Result(Nil, Error)\n\nSynonyms:\nmigrant/filesystem.load_migration_files\nmigrant/filesystem load_migration_files","url":"migrant/filesystem.html#load_migration_files"},{"doc":"migrant/filesystem","title":"migrant/filesystem","content":"","url":"migrant/filesystem.html"},{"doc":"migrant","title":"migrate","content":"pub fn migrate(\n  db: Connection,\n  migration_dir: String,\n) -&gt; Result(Nil, Error)\n\nSynonyms:\nmigrant.migrate\nmigrant migrate","url":"migrant.html#migrate"},{"doc":"migrant","title":"migrant","content":"","url":"migrant.html"}]);